"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var viewport_ruler_1 = require("./viewport-ruler");
var ScrollObservable = /** @class */ (function () {
    function ScrollObservable(_windowRuler) {
        this._windowRuler = _windowRuler;
        if (!ScrollObservable._globalObservable) {
            ScrollObservable._globalObservable = this._getGlobalObservable();
        }
    }
    ScrollObservable.isWindow = function (windowElement) {
        return Object.prototype.toString.call(windowElement).includes('Window');
    };
    ScrollObservable.prototype._getGlobalObservable = function () {
        var _this = this;
        return rxjs_1.merge(rxjs_1.fromEvent(window.document, 'scroll'), rxjs_1.fromEvent(window, 'resize')).pipe(operators_1.tap(function (event) { return _this._windowRuler.onChange(); }), operators_1.share());
        /*
            return Observable.merge(
              Observable.fromEvent(window.document, 'scroll'),
              Observable.fromEvent(window, 'resize')
              .map((event: any) => {
                this._windowRuler.onChange();
                return event;
            })
            ).share();
            */
    };
    ScrollObservable.prototype.scrollObservableFor = function (windowElement) {
        if (ScrollObservable.isWindow(windowElement)) {
            return ScrollObservable._globalObservable;
        }
        if (ScrollObservable._elementObservableReferences.has(windowElement)) {
            return ScrollObservable._elementObservableReferences.get(windowElement);
        }
        var ref = this._createElementObservable(windowElement);
        ScrollObservable._elementObservableReferences.set(windowElement, ref);
        return ref;
    };
    ScrollObservable.prototype._createElementObservable = function (windowElement) {
        return rxjs_1.fromEvent(windowElement, 'scroll').pipe(operators_1.share());
    };
    ScrollObservable._elementObservableReferences = new Map();
    ScrollObservable.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ScrollObservable.ctorParameters = function () { return [
        { type: viewport_ruler_1.WindowRuler, },
    ]; };
    return ScrollObservable;
}());
exports.ScrollObservable = ScrollObservable;
//# sourceMappingURL=scroll-observable.js.map